from cherrypy import cpg

import cherryflow
class RealWorldFlow:
    GET_NAME_HTML = "<form method='post' action='/?_resume=%d'>Name: <input type='text' name='name' /><input type='submit' value='submit' /></form>"
    GET_EMAIL_HTML = "<form method='post' action='/?_resume=%d'>E-mail: <input type='text' name='email' /><input type='submit' value='submit' /></form>"
    GET_ZIPCODE_HTML = "<form method='post' action='/?_resume=%d'>Zipcode: <input type='text' name='zipcode' /><input type='submit' value='submit' /></form>"
    RESULT_HTML = "Name: %s<br />E-mail: %s<br />Zip code: %s<br />"
    def get_name(self):
        yield self.GET_NAME_HTML % cpg.request.resume_id
        while True:
            if len(cpg.request.paramMap.get("name","")) > 0:
                break
            yield "You must enter a valid name!<br />" + self.GET_NAME_HTML % cpg.request.resume_id
    def get_email(self):
        yield self.GET_EMAIL_HTML % cpg.request.resume_id
        while True:
            if len(cpg.request.paramMap.get("email","")) > 0:
                break
            yield "You must enter a valid email!<br />" + self.GET_EMAIL_HTML % cpg.request.resume_id
    def get_zipcode(self):
        yield self.GET_ZIPCODE_HTML % cpg.request.resume_id
        while True:
            if len(cpg.request.paramMap.get("zipcode","")) == 5:
                try:
                    int(cpg.request.paramMap.get("zipcode",""))
                    return
                except ValueError:
                    pass
            yield "You must enter a valid zipcode!<br />" + self.GET_ZIPCODE_HTML % cpg.request.resume_id
    @cpg.expose
    @cherryflow.flow
    def index(self):
        yield self.get_name()
        name = cpg.request.paramMap["name"]
        yield self.get_email()
        email = cpg.request.paramMap["email"]
        yield self.get_zipcode()
        zipcode = cpg.request.paramMap["zipcode"]
        yield self.RESULT_HTML % (name, email, zipcode)

if __name__ == "__main__":
    cpg.root = RealWorldFlow()
    cpg.server.start(configDict={'socketPort':8080,'sessionStorageType':'ram'})
